#include <iostream.h>
#include <string.h>
#include <conio.h>
#include <fstream.h>

#define LEN 100 //Lunghezza massima delle stringhe
#define N 600 //Dimensione fisica del vettore di stringhe

void stampa_firma ( ) {
	cout << " mauromalvestio@tiscali.itͻ" << endl;
	cout << "  Mauro Malvestio - 473678 STI                                     12/11/02  " << endl;
	cout << "  Sistemi di Elaborazione II                                     Compito #3  " << endl;
	cout << " ͼ" << endl;
}//STAMPA_FIRMA

//converte da minuscole a maiuscole
void str_upper ( char vett[LEN] ) {
	for (int i=0; i<strlen(vett); i++ )
		vett[i] = vett[i] >= 'a' && vett[i] <= 'z' ? vett[i]-32 : vett[i];
}//TO_UPPER

//converte da maiuscole a minuscole
void str_lower ( char vett[] ) {
	for ( int i=0; i < strlen(vett); i++ )
		vett[i] = vett[i] >= 'A' && vett[i] <= 'Z' ? vett[i]+32 : vett[i];
}//TO_UPPER

//esegue una classica ricerca con sentinella con
//complessita computazionale O(n^2)
void sentinella ( char vett[][LEN], int ldx ) {
	register int i,j;
	char temp[LEN];
	for ( i = 0; i < ldx; i++ )
		for ( j = i+1; j < ldx; j++ )
			if ( strcmp ( vett[i], vett[j]) > 0 ) {
				strcpy(temp,vett[i]);
				strcpy(vett[i],vett[j]);
				strcpy(vett[j],temp);
			}//THEN
}//SENTINELLA

//legge da path(file) e inserisci l'imput in vett, return n di vett
int leggi_file ( char path[], char vett[][LEN]) {
	fstream file;
	int i;
	file.open(path,ios::in);
	if ( ! file ) {
		return -1;
	}//THEN
	i = 0;
	while ( ! file.eof() ) {
		file.getline(vett[i],LEN,'\n');
		i++;
	}//WHILE
	file.close();
	return i;
}//LEGGI_FILE

//Scrive vett nel file indicato in path, return -1 in caso di errore.
int scrivi_file ( char path[], char vett[][LEN], int n) {
	fstream file;
	int i;
	file.open(path,ios::out);
	if ( ! file ) {
		return -1;
	}//THEN
	for ( i = 0; i < n; i++ )
		file << vett[i] << "\n";
	file.close();
	return i;
}//LEGGI_FILE

int main ( ) {
	char vett_string[N][LEN], //vettore di stringhe per contenere i nomi
		 path[256]; //vettpre per contenere il percorso dei file
	int i,n;
	clrscr();
	stampa_firma();
	cout << endl << "Inserire il nome con i file degli studenti da ordinare" << endl << "PATH : ";
	cin.getline(path,256,'\n');
	n=leggi_file(path,vett_string);
	if ( n == -1 ) {
		cout << "[ERRORE : IMPOSSIBILE APRIRE IL FILE";
		return 0;
	}//THEN
	for ( i = 0; i < n;  i++ )
		str_lower(vett_string[i]); //trasforma tutti i char in minuscoli
	cout << "Il numero di studenti letti da " << path << " e : " << n;
	sentinella(vett_string,n); //ordina il vettore di stringhe
	cout << endl << "Ordinamento a dizionario terminato";
	cout << endl << "Inserire il nome del file contenente i nomi ordinati" << endl << "PATH : ";
	cin.getline(path,256,'\n');
	if(scrivi_file(path,vett_string,n)) //scive su file il vettore ordinato
		cout << "Il file " << path << "  stato creato con successo." << endl;
	return 0;
}//MAIN