#include <iostream.h>
#include <iomanip.h>
#include <fstream.h>
#include <string.h>

/*Programma che riordina il file contenente i nomi degli studenti;l'utente inserisce lo studente di cui 
vuole inserire il voto e viene salvato il nome con il relativo voto in un altro file "studenti_voti.dat"*/

int lettura_file(char [300][40]);
int trova_posizione_minimo(char [300][40],int,int);
void scambia(char[],char[]);
void stampa_dati(char [],char [300][40],int);
int ricerca(char[300][40],int,char[]);
int confronta(char[],char[]);
void stampa(char[],int);
void inserimento(int [300]);

int main()
{
	cout<<"Programma che consente l'inserimento del voto di uno studente cercato"<<endl;
	char nomi[300][40],studente[300][40],trova[40],c;
	int tot,trovato,k,voto[300];
	tot=lettura_file(nomi);
	for(int i=0;i<tot;i++)
	{
		trovato=trova_posizione_minimo(nomi,i,tot);
		scambia(nomi[i],nomi[trovato]);
	}
	stampa_dati("Dati ordinati ",nomi,tot);
	int j=0;
	fstream file;
	file.open("studenti_voti.dat",ios::out);
	cout <<"Per uscire dal programma digitare CTRL+Z"<<endl;
	cout<<"Inserire il nome da cercare  ";
	cin.getline(trova,40,'\n');
	while(!cin.eof())
	{
		k=ricerca(nomi,tot,trova);
		if(k<0)
		{
			cout << "IL NOME RICERCATO NON ESISTE ";
			cout<<"Inserire il nome da cercare  ";
			cin.getline(trova,40,'\n');
		}
		else
		{
			strcpy(studente[j],trova);
			cout <<"Inserire il voto dello studente  ";
			cin>>voto[j];
			cin.get(c);
			file<<setiosflags(ios::left)<<setw(40)<<studente[j]<<setw(5)<<voto[j]<<endl;
			j++;
			cout<<endl<<"Inserire il nome da cercare  ";
			cin.getline(trova,40,'\n');
		}
	}
	cout <<endl<<"(I dati inseriti sono contenuti nel file 'studenti_voti.dat')";
	cout <<endl<<"Studente"<<setw(35)<<" Voto "<<endl;
	for (int a=0;a<j;a++)
		cout<<setiosflags(ios::left)<<setw(40)<<studente[a]<<setw(5)<<voto[a]<<endl;
	return 0;
}

int lettura_file(char nomi[300][40])
{
	char nome_file[20];
	cout <<"Inserire il nome del file che contiene i nomi degli studenti   ";
	cin.getline(nome_file,20,'\n');
	fstream nomi_letti;
	nomi_letti.open(nome_file,ios::in); //apertura del file in lettura
	if (!nomi_letti)  //controllo dell'esistenza del file
	{
		cout <<"Impossibile aprire il file";
		return 1 ;
	}
	int i=0;
	nomi_letti.getline(nomi[i],40,'\n');
	while(!nomi_letti.eof())
	{
		i++; //contatore del numero di studenti
		nomi_letti.getline(nomi[i],40,'\n');
	}
	cout <<"Il numero degli studenti inseriti nel file '"<<nome_file<<"' e': "<<i<<endl;
	nomi_letti.close();
	return i;  //da al main il numero di studenti
}

int trova_posizione_minimo(char nomi[300][40],int i,int n)
{
	int posizione;
	char minimo[40];
	strcpy(minimo,nomi[i]);
	posizione=i;
	for (int k=i+1;k<n;k++)
	{
		if(strcmp(minimo,nomi[k])>0)
		{
			strcpy(minimo,nomi[k]);
			posizione=k;
		}
	}
	return posizione;
}
void scambia(char x[],char y[])
{
	char temporaneo[40];
	strcpy(temporaneo,x);
	strcpy(x,y);
	strcpy(y,temporaneo);
	return;
}

void stampa_dati(char scritta[],char nomi[250][40],int n)
{
	cout << endl << scritta << endl;
	for(int i=0;i<n;i++)
		cout << nomi[i] <<endl;
	cout << endl;
	return;
}

int ricerca(char nomi[300][40],int n,char trova[])
{
	int k,i=0;
	char studente[300][40];
	for(int j=0;j<n;j++)
	{
		k=confronta(nomi[j],trova);
		if(k==0)
		{
			//strcpy(studente[i],trova);
			i++;
			return j;
		}
	}
	return -1;
}

int confronta(char x[],char y[])
{
	int k,lunghezza;
	lunghezza=strlen(y);
	k=strncmp(x,y,lunghezza);
	if(k==0)
		return 0;
	else
		return 1;
}

