#include <iostream.h>
#include <iomanip.h>
#include <fstream.h>
#include <string.h>

int lettura_dati(char [250][50],int []);
void stampa_dati(char [250][50],int [],int);
int confronta(char [] ,char [] );
int ricerca(char [250][50],int, int ,char [] );

void classifica(int [],int, int[]);
void classifica_nuova(int [],int, int[]);
void stampa_classi(int []);

int main()
{
	char x[250][50],chiave[50];
	int k,j,numero_dati,voti[250],i=0, inizio;
	//classificazione dei soli voti positivi
	int classi[13], classi_1[13];
	//lettura dei dati da file
	numero_dati=lettura_dati(x,voti);
	//stampa dei dati letti
	stampa_dati(x,voti,numero_dati);
	cout << endl;
	cout << "Inserire lo studente da ricercare  : ";
	cin.getline(chiave,50,'\n');
	//ricerca dello studente voluto dall'utente
	inizio=0;
	k=ricerca(x,numero_dati,inizio,chiave);
	
	if (k<0)
		cout << "Lo studente cercato non esiste !!!!!! "<<endl;
	else
	{
		cout << "Lo studente cercato e' il numero : " << k << endl;
		cout << "ed e' : " << x[k] << "  con voto  ;  " << voti[k]<<endl; 
	}
	
	//ricerca e stampa di tutti gli studenti con nome (o parte del nome) 
	//uguale alla chiave immessa
	k=1;
	inizio=0;
	while(k>0)
	{
		k=ricerca(x,numero_dati,inizio,chiave);
		inizio=k+1;
		if (k<0)
			cout << "Ho terminato la ricerca "<<endl;
		else
		{
			cout << "Lo studente cercato e' il numero : " << k << endl;
			cout << "ed e' : " << x[k] << "  con voto  ;  " << voti[k]<<endl; 
		}
	}
	
	//classificazione di voti degli studenti: solo quelli positivi
	classifica(voti,numero_dati,classi);
	//classificazione con un altro algoritmo (migliore)
	classifica_nuova(voti,numero_dati,classi_1);
	
	//stampa della classificazione effettuata
	stampa_classi(classi);
	
	stampa_classi(classi);
	
	return 0;	 
}

int lettura_dati(char x[250][50],int voti[250])
{
	//lettura dati da file: il promo contiene i nomi degli studenti
	//il secondo i corrispondenti voti
	fstream dati,voto;
	int i=0;
	
	dati.open("nomi.txt",ios::in);
	voto.open("voto.txt",ios::in);
	//controllo dell'esistenza dei file
	if(!dati || !voto)
	{
		cout << "ATTENZIONE: I file dati non esistono ";
		return -1;
	}
	//lettura esterna per controllo eof
	dati.getline(x[i],30,'\n');
	voto>>voti[i];
	//cout <<x[i]<<voti[i]<< endl;
	while(!dati.eof())
	{
		i++;
		dati.getline(x[i],30,'\n');
		voto>>voti[i];
		//cout << x[i]<<" "<<voti[i]<<endl;
	}
	return i-1;
}

void stampa_dati(char x[250][50],int voti[250],int n)
{
	//stampa dei dati letti
	cout << setw(50) << setiosflags(ios::left)<< "    Cognome e nome" << "Voto"<<endl<<endl;
	for (int i=0;i<n;i++)
	{
		cout << setw(50)<<setiosflags(ios::left)<<x[i]<<setw(5)<<voti[i]<<endl;
	}
	return;
}

int ricerca(char x[250][50],int n,int inizio, char chiave[])
{
	//funzione di ricerca di uno studente
	//il nome da ricercare e' contenuto in chiave
	int l,k;
	//k=strlen(chiave); //meglio se la lunghezza della stringa calcolata fuori ciclo
	for (int i=inizio;i<n;i++)
	{
		//calcolo la lunghezza della stringa immessa (puo' essere solo una parte del nome)
		k=strlen(chiave);
		//la funzione seguente controlla il nome immesso cosi' come immesso
		//l=strncmp(x[i],chiave,k);
		//la funzione che segue controlla il nome immesso indipendentemente se si sono
		//utilizzati caratteri maiuscoli e/o minuscoli
		l=strnicmp(x[i],chiave,k);
		if(l==0)
		//se ha trovato il nome immesso ritorna la posizione dell'array dove si trova lo studente
			return i;
	}
	//ritorna il valore negativo se la ricerca non e' andata a buon fine
	return -1;
}

		
void classifica(int voti[],int n, int classi[])
{
//funzione di classificazione dei voti 
//l'algoritmo utilizzato non e' molto funzionale
//poiche' il numero di operazioni che deve fare sono molte di cui alcune inutili
	for (int m=0;m<13;m++)
		classi[m]=0; 
	int k,j;
	for (j=0;j<n;j++)
	{
		if(voti[j]>=18)
		{
			k=0;
			for(int i=18;i<=30;i++)
			{
				if(voti[j]==i)
					classi[k]++;
				k++;
			}
		}
	}
	return;
		
}

void classifica_nuova(int voti[],int n, int classi[])
{
//l'algoritmo di classificazione usato e' migliore dell'altro
//e sfrutta il fatto che si puo' utilizzare diretttamente come indice 
//dell'array una trasformazione lineare del voto
	for (int m=0;m<13;m++)
		classi[m]=0; 
	int k;
	for(int i=0;i<n;i++)
	{
		if(voti[i]>=18)
		{
			k=voti[i]-18;
			//k puo' assumere i valori da 0 a 12 (18-18 = 0;  19-18 = 1;  ... 30-18 = 12)
			classi[k]++;
		}
	}
	return;
}

void stampa_classi(int classi[])
{
	cout << "La classificazione degli studenti e' la seguente : " << endl;
	for (int i=18;i<=30;i++)
	{
		cout << setw(5) << i << setw(5) << classi[i-18] << endl;
	
	}
	return;
}	   	   
