/* ------------------------------------------------------------------------- *
 * Cavalin Alberto | Matr. 472802 | Esercizio numero 2 | PC032 | 07/Nov/2002 *
 * ------------------------------------------------------------------------- */


// [ Librerie delle funzioni di sistema ] ------------------------------------
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
#include <string.h>
#include <stdlib.h>
// ---------------------------------------------------------------------------


// [ Defines, macro, ecc...             ] ------------------------------------
#define clrscr() system("cls")

enum BOOL { FALSE, TRUE };
// ---------------------------------------------------------------------------


// [ Prototipi delle funzioni usate     ] ------------------------------------
void f_open(char nome[],fstream *file,BOOL read);
// ---------------------------------------------------------------------------


/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * MAIN: Funzione principale                                                 *
 * I : \   | \                                                               *
 * O : int | codice di uscita del programma                                  *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
int main() {
    clrscr();				//pulitura dello schermo

	//dichiarazione delle variabili
    char nome[30];          //stringa per i nomi
    int voto,               //voto dello studente
        somma=0,			//media dei voti
		n=0;				//variabile contatore del numero di studenti
    fstream fin,fout;       //streams per la manipolazione dei dati   

	//apertura dei file per la gestione dei dati
    f_open("studenti.txt",&fin,TRUE);   //apertura file dei nomi
    f_open("voti.txt",&fout,FALSE);     //apertura file di output

	//stampa dell'intestazione
    fout<<"+------------------------------+----------+\n";
    fout<<"|        Cognome e nome        |   Voto   |\n";
    fout<<"+------------------------------+----------+\n";

	//richiesta dei dati e loro inserimento nel file
    while (!fin.eof()) {                //leggi finche' non termina il file
		fin.getline(nome,29,'\t');		//lettura del nome
        if (strlen(nome)>1) {			//controllo di non leggere un '\n'
			n++;						//incremento il contatore dei voti
			cout<<"Inserire il voto di "<<nome<<": ";
			cin>>voto;
			somma+=voto;				//incremento la somma dei voti
			fout<<'|'<<setw(29)<<nome<<" |"<<setw(9)<<voto<<" |\n";
			fout<<"+------------------------------+----------+\n";
			fin.getline(nome,29,'\n');  //eliminazione del '\n'
        }//if
    }//while

	//stampa della media dei voti
	fout<<"| Media dei voti               |"<<setw(9)<<((float)somma/n)<<" |\n";
	fout<<"+------------------------------+----------+\n";

    return 0;
}//main

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * F_OPEN: Apre un file eseguendo i dovuti controlli                         *
 * I1: nome | nome del file da aprire                                        *
 * I2: file | stream del file                                                *
 * I3: read | tipo di streaming: lettura/scrittura                           *
 * O : \    | \                                                              *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
void f_open(char nome[],fstream *file,BOOL read) {
    file->open(nome,(read?(ios::in):(ios::out)));
    if (!(*file)) { //se il file non e' stato aperto correttamente
        cout<<"Errore nell'apertura del file \""<<nome<<"\"!\n";
        exit(-1);
    }//if
}//f_open

